unit AboutFormUnit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, Buttons;

type

  { TAboutForm }

  TAboutForm = class(TForm)
    Button1: TButton;
    Image1: TImage;
    Label_or_Tsukuba: TLabel;
    Label_Version: TLabel;
    Label_MadeInIshigakiIsland: TLabel;
    Label_photohito: TLabel;
    Label_Copyright: TLabel;
    Label_flickr: TLabel;
    Label_Title: TLabel;
    SpeedButton1: TSpeedButton;
    StaticText_with_Lazarus: TStaticText;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure Label_MadeInIshigakiIslandClick(Sender: TObject);
    procedure Label_MadeInIshigakiIslandMouseEnter(Sender: TObject);
    procedure Label_MadeInIshigakiIslandMouseLeave(Sender: TObject);
    procedure Label_photohitoClick(Sender: TObject);
    procedure Label_photohitoMouseEnter(Sender: TObject);
    procedure Label_photohitoMouseLeave(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    function GetVersionText: string;
    { private declarations }
  public
    { public declarations }
    property VersionText: string read GetVersionText;
  end; 

var
  AboutForm: TAboutForm;

implementation

{$R *.lfm}

uses Windows;

{ TAboutForm }

procedure TAboutForm.FormCreate(Sender: TObject);
begin
  Label_Title.Caption := Application.Title;
end;

procedure TAboutForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if(Key = VK_ESCAPE)and(Shift = [])then
  begin
    ModalResult := mrCancel;
    Key := 0;
  end;
end;

procedure TAboutForm.FormShow(Sender: TObject);
begin
  Image1.Picture.Assign(Application.Icon);
end;

procedure TAboutForm.Label_MadeInIshigakiIslandClick(Sender: TObject);
begin
  if Sender = Label_MadeInIshigakiIsland then
    Windows.ShellExecuteW(Handle, 'open',
      'http://maps.google.co.jp/maps?q=24.377824,124.194844',
      nil, nil, SW_NORMAL)
  else if Sender = Label_or_Tsukuba then
    Windows.ShellExecuteW(Handle, 'open',
      'http://maps.google.co.jp/maps?q=36.054600,140.086900',
      nil, nil, SW_NORMAL);
end;

procedure TAboutForm.Label_MadeInIshigakiIslandMouseEnter(Sender: TObject);
begin
  if Sender is TLabel then
    TLabel(Sender).Font.Style := [fsItalic, fsUnderLine];
end;

procedure TAboutForm.Label_MadeInIshigakiIslandMouseLeave(Sender: TObject);
begin
  if Sender is TLabel then
    TLabel(Sender).Font.Style := [fsItalic];
end;

procedure TAboutForm.Label_photohitoClick(Sender: TObject);
begin
  if (Sender is TLabel)and(TLabel(Sender).Hint <> '') then
    Windows.ShellExecuteW(Handle, 'open',
      PWideChar(UTF8Decode(TLabel(Sender).Hint)),
      nil, nil, SW_NORMAL);
end;

procedure TAboutForm.Label_photohitoMouseEnter(Sender: TObject);
var
  FontStyle: TFontStyles;
begin
  if (Sender is TLabel) then
  begin
    FontStyle := TLabel(Sender).Font.Style;
    Include(FontStyle, fsUnderLine);
    Include(FontStyle, fsItalic);
    TLabel(Sender).Font.Style := FontStyle;
  end;
end;

procedure TAboutForm.Label_photohitoMouseLeave(Sender: TObject);
var
  FontStyle: TFontStyles;
begin
  if (Sender is TLabel) then
  begin
    FontStyle := TLabel(Sender).Font.Style;
    Exclude(FontStyle, fsUnderLine);
    Exclude(FontStyle, fsItalic);
    TLabel(Sender).Font.Style := FontStyle;
  end;
end;

procedure TAboutForm.SpeedButton1Click(Sender: TObject);
begin
  Windows.ShellExecuteW(Handle, 'open',
    'http://maps.google.co.jp/maps?q=24.338236,124.157808',
    nil, nil, SW_NORMAL);
end;

function TAboutForm.GetVersionText: string;
begin
  Result := Self.Label_Version.Caption;
end;

end.

