unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ComCtrls,
  LCLType, Menus, ActnList, ExtCtrls, StdCtrls, Buttons, IniFiles, TreeStrings,
  Windows;

type

  { TForm1 }

  TForm1 = class(TForm)
    Action_FileEndStr_in_Saving: TAction;
    Action_EditFindNext_Reverse: TAction;
    Action_EditFindNext: TAction;
    Action_EditFind: TAction;
    Action_ViewFont: TAction;
    Action_WordWrap: TAction;
    Action_View_EditingProperty: TAction;
    Action_HelpAbout: TAction;
    Action_FileSaveAs: TAction;
    Action_TreeNode_Bottom: TAction;
    Action_TreeNode_Top: TAction;
    Action_TreeNode_Down: TAction;
    Action_TreeNode_Up: TAction;
    Action_TreeNode_AddNext: TAction;
    Action_TreeNode_Delete: TAction;
    Action_TreeNode_AddChild: TAction;
    Action_FileExit: TAction;
    Action_FileSave: TAction;
    Action_FileNew: TAction;
    Action_FileOpen: TAction;
    ActionList1: TActionList;
    FontDialog1: TFontDialog;
    Label_EditingProperty: TLabel;
    MainMenu1: TMainMenu;
    Memo1: TMemo;
    MenuItem1: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem_EndStr_in_Saving: TMenuItem;
    MenuItem_PopupPaste: TMenuItem;
    MenuItem_PopupCopy: TMenuItem;
    MenuItem_PopupCut: TMenuItem;
    MenuItem_PoupuSeparator: TMenuItem;
    MenuItem_PopupUndo: TMenuItem;
    MenuItem_EditFindNext: TMenuItem;
    MenuItem_EditFind: TMenuItem;
    MenuItem_EditProperty: TMenuItem;
    MenuItem_Edit: TMenuItem;
    MenuItem_Font: TMenuItem;
    MenuItem_WordWrap: TMenuItem;
    MenuItem_View: TMenuItem;
    MenuItem_Help: TMenuItem;
    MenuItem_About: TMenuItem;
    MenuItem_FileSaveAs: TMenuItem;
    MenuItem_DelNode: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    MenuItem_FileExit: TMenuItem;
    MenuItem_FileSeparator: TMenuItem;
    MenuItem_FileSave: TMenuItem;
    MenuItem_FileNew: TMenuItem;
    MenuItem_FileOpen: TMenuItem;
    MenuItem_File: TMenuItem;
    OpenDialog1: TOpenDialog;
    PopupMenu_Memo1: TPopupMenu;
    PopupMenu_TreeView1: TPopupMenu;
    SaveDialog1: TSaveDialog;
    Splitter1: TSplitter;
    StatusBar1: TStatusBar;
    TreeView1: TTreeView;
    procedure Action_EditFindExecute(Sender: TObject);
    procedure Action_EditFindNextExecute(Sender: TObject);
    procedure Action_EditFindNext_ReverseExecute(Sender: TObject);
    procedure Action_FileExitExecute(Sender: TObject);
    procedure Action_FileNewExecute(Sender: TObject);
    procedure Action_FileOpenExecute(Sender: TObject);
    procedure Action_FileSaveAsExecute(Sender: TObject);
    procedure Action_FileSaveExecute(Sender: TObject);
    procedure Action_HelpAboutExecute(Sender: TObject);
    procedure Action_TreeNode_AddChildExecute(Sender: TObject);
    procedure Action_TreeNode_AddNextExecute(Sender: TObject);
    procedure Action_TreeNode_BottomExecute(Sender: TObject);
    procedure Action_TreeNode_DeleteExecute(Sender: TObject);
    procedure Action_TreeNode_DownExecute(Sender: TObject);
    procedure Action_TreeNode_TopExecute(Sender: TObject);
    procedure Action_TreeNode_UpExecute(Sender: TObject);
    procedure Action_ViewFontExecute(Sender: TObject);
    procedure Action_View_EditingPropertyExecute(Sender: TObject);
    procedure Action_WordWrapExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure MenuItem_FileClick(Sender: TObject);
    procedure PopupMenu_Memo1Popup(Sender: TObject);
    procedure PopupMenu_TreeView1Popup(Sender: TObject);
    procedure TreeView1Click(Sender: TObject);
    procedure TreeView1DblClick(Sender: TObject);
    procedure TreeView1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure TreeView1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure TreeView1Edited(Sender: TObject; Node: TTreeNode; var S: string);
    procedure TreeView1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TreeView1SelectionChanged(Sender: TObject);
  private
    { private declarations }
    FTreeStrings: TTreeStrings;
    FFileName: string;
    FModified: Boolean;
    FTreeStringsItem_of_Memo: TTreeStringsItem;
    procedure Set_TreeStringsItem_of_Memo(AItem: TTreeStringsItem);
    procedure UpdateCaption_by_FileName();
    function CreateIniFile: TIniFile;
    procedure WMUser(var Msg: TMessage); message WM_USER;
  protected
    procedure AddNode_Next(Node: TTreeNode);
    procedure AddNode_Child(Node: TTreeNode);
    procedure DelNode(Node: TTreeNode);
    procedure MoveNode_Up(Node: TTreeNode);
    procedure MoveNode_Down(Node: TTreeNode);
    procedure MoveNode_Top(Node: TTreeNode);
    procedure MoveNode_Bottom(Node: TTreeNode);
    procedure Set_EditingProperty(AVisible: Boolean);
    function Q_Save_ModifiedData: Integer;
    procedure Do_NewFile();
    function Do_SaveFile(): Boolean;
    function Do_SaveFileAs(): Boolean;
    procedure MakeTreeView; inline overload;
    procedure MakeTreeView(ANode: TTreeNode; AItem: TTreeStringsItem); overload;
    function SelectNode_by_Item(AItem: TTreeStringsItem): TTreeNode;
  public
    { public declarations }
    procedure LoadFromFile(AFileName: string);
    function SaveToFile(AFileName: string): Boolean;
    function FindWord(AKeyword: WideString; ACaseSensitive, AWholeFile, AForward: Boolean): Boolean;
  end;

var
  Form1: TForm1;

procedure DEBUG(S: string); overload;
procedure DEBUG(S1, S2: string); overload;

implementation

{$R *.lfm}

uses Clipbrd, FindWordUnit, AboutFormUnit;

procedure DEBUG(S: string);
begin
  ShowMessage('DEBUG' + #13#10 + S);
end;

procedure DEBUG(S1, S2: string);
begin
  ShowMessage('DEBUG' + #13#10 + S1 + #13#10 + S2);
end;

function Strings_LoadFromFile(Strings: TStrings; const FileName: string): Boolean;
var
  MS: TMemoryStream;
  PB: PBYTE;
  BOM: array[0..2] of BYTE;
  DW: DWORD;
  PW: PWORD;
  W: WORD;
  I: Integer;
  AnsiStr: AnsiString;
const
  Mode = fmOpenRead or fmShareDenyNone;

  procedure _Load(Dst: TMemoryStream);
  var
    FS: TFileStream;
  begin
    FS := TFileStream.Create (FileName, Mode);
    try
      Dst.LoadFromStream(FS);
    finally
      FS.free;
    end;
  end;

  function _AnsiToWideString(S: AnsiString): WideString; inline;
  var
    L: longint;
  begin
    L := Windows.MultiByteToWideChar(932, 0, PChar(S), -1, nil, 0);
    SetLength(Result, L);
    Windows.MultiByteToWideChar(932, 0, PChar(S), -1, PWideChar(Result), L);
  end;
  function _AnsiToUtf8(S: AnsiString): string; inline;
  begin
    Result := Utf8Encode(_AnsiToWideString(S));
  end;
  function _WideStringToAnsi(WS: WideString): AnsiString;
  var
    L: longint;
  begin
    L := Windows.WideCharToMultiByte(932, 0, PWideChar(WS), -1, nil, 0, nil, nil);
    SetLength(Result, L);
    L := Windows.WideCharToMultiByte(932, 0, PWideChar(WS), -1, PChar(Result), L, nil, nil);
    Result := AnsiString(PChar(Result));
  end;
  function _Utf8ToAnsi(S: string): AnsiString; inline;
  begin
    Result := _WideStringToAnsi(Utf8Decode(S));
  end;
begin
  Result := FALSE;
  Strings.Clear;
  if (not Assigned(Strings))or(not FileExists(FileName)) then
    Exit;

  MS := TMemoryStream.Create;
  try
    _Load(MS);
    if MS.Size > 0 then
    begin
      // 先頭の*でファイルタイプを判別する（無いものは・・・あきらめ？）
      if MS.Size > 2 then
      begin
        PB := PBYTE(MS.Memory);
        BOM[0] := PB^; Inc(PB);
        BOM[1] := PB^; Inc(PB);
        BOM[2] := PB^;
      end
      else
      begin
        BOM[0] := 0; BOM[1] := 0; BOM[2] := 0;
      end;
      if (BOM[0] = $ef)and(BOM[1] = $bb)and(BOM[2] = $bf)then
      begin
        // UTF-8
        MS.Position := MS.Size;
        DW := 0;
        MS.Write(DW, 1);
        PB := PBYTE(MS.Memory);
        Inc(PB, 3);
        Strings.Text := PChar(PB);
      end
      else if (BOM[0] = $ff)and(BOM[1] = $fe)then
      begin
        // Unicode Little Endian
        MS.Position := MS.Size;
        DW := 0;
        MS.Write(DW, 2);
        PB := PBYTE(MS.Memory);
        Inc(PB, 2);
        Strings.Text := UTF8Encode(WideString(PWideChar(PB)));
      end
      else if (BOM[0] = $fe)and(BOM[1] = $ff)then
      begin
        // Unicode Big Endian
        MS.Position := MS.Size;
        DW := 0;
        MS.Write(DW, 2);
        PB := PBYTE(MS.Memory);
        Inc(PB, 2);
        PW := PWORD(PB);
        for I := (MS.Size - 2) div 2 - 1 downto 0 do
        begin
          W := PW^;
          W := (W shl 8 and $ff00)or(W shr 8 and $00ff);
          PW^ := W;
          Inc(PW);
        end;
        Strings.Text := UTF8Encode(WideString(PWideChar(PB)));
      end
      else // BOMが無い
      begin
        // 自動判定を試みる
        MS.Position := MS.Size;
        DW := 0;
        MS.Write(DW, 1);
        //Strings.Text := System.AnsiToUtf8(PAnsiChar(MS.Memory));
        AnsiStr := PAnsiChar(MS.Memory);
        //if AnsiStr = System.Utf8ToAnsi(System.AnsiToUtf8(AnsiStr)) then
        if PChar(MS.Memory) = Utf8Encode(Utf8Decode(PChar(MS.Memory))) then
        begin
          //ShowMessage('自動判定：UTF-8');
          Strings.Text := PChar(MS.Memory);
        end
        else if AnsiStr = _Utf8ToAnsi(_AnsiToUtf8(AnsiStr)) then
        begin
          //ShowMessage('自動判定：ANSI');
          //Strings.Text := System.AnsiToUtf8(PAnsiChar(MS.Memory));
          Strings.Text := _AnsiToUtf8(AnsiStr);
        end
        else
        begin
          //ShowMessage('自動判定：失敗');
          {
          // Ansi として処理
          //Strings.Text := System.AnsiToUtf8(PAnsiChar(MS.Memory));
          Strings.Text := _AnsiToUtf8(PAnsiChar(MS.Memory));
          }
          // BOM無しの UTF-8 として処理
          MS.Position := MS.Size;
          DW := 0;
          MS.Write(DW, 1);
          PB := PBYTE(MS.Memory);
          Strings.Text := PChar(PB);
        end;
      end;

      Result := TRUE;
    end;
  finally
    MS.Free;
  end;
end;

function Strings_SaveToFile(Strings: TStrings; const FileName: string): Boolean;
var
  FS: TFileStream;
  S: string;
  BOM: array[0..2] of BYTE;
begin
  FS := TFileStream.Create(FileName, fmCreate);
  try
    BOM[0] := $ef;
    BOM[1] := $bb;
    BOM[2] := $bf;
    FS.Write(BOM[0], 1);
    FS.Write(BOM[1], 1);
    FS.Write(BOM[2], 1);
    S := Strings.Text;
    FS.Write(PChar(S)^, Length(S) * sizeof(Char));
    Result := FS.Size = (3 + Length(S) * sizeof(Char));
  finally
    FS.Free;
  end;
end;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  Ini: TIniFile;
begin
  FTreeStrings := TTreeStrings.Create;
  Caption := Application.Title;

  Ini := CreateIniFile();
  try
    Self.Font.Name := Ini.ReadString('Font', 'Name', Self.Font.Name);
    Self.Font.Size := Ini.ReadInteger('Font', 'Size', Self.Font.Size);
  finally
    Ini.Free;
  end;
  // ParentFontプロパティをTRUEにしているので要らないはずですが、念のため
  Memo1.Font.Assign(Self.Font);
  TreeView1.Font.Assign(Self.Font);

  Do_NewFile();
end;

procedure TForm1.Action_FileExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Action_EditFindExecute(Sender: TObject);
begin
  FindWordForm.Show;
end;

procedure TForm1.Action_EditFindNextExecute(Sender: TObject);
begin
  FindWordForm.Keyword := Trim(FindWordForm.Keyword);
  if FindWordForm.Keyword = '' then
    FindWordForm.Show
  else if FindWordForm.SearchForward then
    PostMessage(Handle, WM_USER, 0, 1)
  else
    PostMessage(Handle, WM_USER, 0, 0);
end;

procedure TForm1.Action_EditFindNext_ReverseExecute(Sender: TObject);
begin
  FindWordForm.Keyword := Trim(FindWordForm.Keyword);
  if FindWordForm.Keyword = '' then
    FindWordForm.Show
  else if FindWordForm.SearchForward then
    PostMessage(Handle, WM_USER, 0, 0)
  else
    PostMessage(Handle, WM_USER, 0, 1);
end;

procedure TForm1.Action_FileNewExecute(Sender: TObject);
var
  IsCanceled: Boolean;
begin
  IsCanceled := FALSE;
  if FModified then
  case Q_Save_ModifiedData() of
    IDYES: if Do_SaveFile() then
      else IsCanceled := TRUE;
    IDNO: ;
    IDCANCEL: IsCanceled := TRUE;
    else      IsCanceled := TRUE;
  end;

  if IsCanceled then
    //ShowMessage('キャンセルされました')
  else
    Do_NewFile();
end;

procedure TForm1.Action_FileOpenExecute(Sender: TObject);
var
  IsCanceled: Boolean;
begin
  IsCanceled := FALSE;
  if FModified then
  case Q_Save_ModifiedData() of
    IDYES: if Do_SaveFile() then
      else IsCanceled := TRUE;
    IDNO: ;
    IDCANCEL: IsCanceled := TRUE;
    else      IsCanceled := TRUE;
  end;

  if IsCanceled then
    //ShowMessage('キャンセルされました')
  else
  begin
    OpenDialog1.InitialDir := ExtractFilePath(FFileName);
    OpenDialog1.FileName := ExtractFileName(FFileName);

    if OpenDialog1.Execute then
    begin
      LoadFromFile(OpenDialog1.FileName);
    end;
  end;
end;

procedure TForm1.Action_FileSaveAsExecute(Sender: TObject);
begin
  Do_SaveFileAs();
end;

procedure TForm1.Action_FileSaveExecute(Sender: TObject);
begin
  if (FFileName <> '')and FileExists(FFileName) then
    SaveToFile(FFileName)
  else
    Do_SaveFileAs();
end;

procedure TForm1.Action_HelpAboutExecute(Sender: TObject);
var
  Form: TAboutForm;
begin
  Form := TAboutForm.Create(Self);
  try
    Form.ShowModal;
  finally
    Form.Free;
  end;
end;

procedure TForm1.Action_TreeNode_AddChildExecute(Sender: TObject);
begin
  AddNode_Child(TreeView1.Selected);
  FModified := TRUE;
end;

procedure TForm1.Action_TreeNode_AddNextExecute(Sender: TObject);
begin
  AddNode_Next(TreeView1.Selected);
  FModified := TRUE;
end;

procedure TForm1.Action_TreeNode_BottomExecute(Sender: TObject);
begin
  MoveNode_Bottom(TreeView1.Selected);
  FModified := TRUE;
end;

procedure TForm1.Action_TreeNode_DeleteExecute(Sender: TObject);
var
  Node: TTreeNode;
begin
  Node := TreeView1.Selected;
  if Assigned(Node) and
    (Node <> TreeView1.Items[0]) and
    (Application.MessageBox(PChar('項目を削除しますか？' + #13#10 + '[' + Node.Text + ']'),
      '項目の削除', MB_ICONQUESTION or MB_OKCANCEL or MB_DEFBUTTON2) = IDOK) then
  begin
    DelNode(Node);
    FModified := TRUE;
  end;
end;

procedure TForm1.Action_TreeNode_DownExecute(Sender: TObject);
begin
  MoveNode_Down(TreeView1.Selected);
  FModified := TRUE;
end;

procedure TForm1.Action_TreeNode_TopExecute(Sender: TObject);
begin
  MoveNode_Top(TreeView1.Selected);
  FModified := TRUE;
end;

procedure TForm1.Action_TreeNode_UpExecute(Sender: TObject);
begin
  MoveNode_Up(TreeView1.Selected);
  FModified := TRUE;
end;

procedure TForm1.Action_ViewFontExecute(Sender: TObject);
var
  Ini: TIniFile;
begin
  FontDialog1.Font.Assign(Self.Font);
  if FontDialog1.Execute then
  begin
    Self.Font.Assign(FontDialog1.Font);
    // ParentFontプロパティをTRUEにしているので要らないはずですが、念のため
    Memo1.Font.Assign(Self.Font);
    TreeView1.Font.Assign(Self.Font);
    Ini := CreateIniFile();
    try
      Ini.WriteString('Font', 'Name', Self.Font.Name);
      Ini.WriteInteger('Font', 'Size', Self.Font.Size);
    finally
      Ini.Free;
    end;
  end;
end;

procedure TForm1.Action_View_EditingPropertyExecute(Sender: TObject);
begin
  Set_EditingProperty(Action_View_EditingProperty.Checked);
end;

procedure TForm1.Action_WordWrapExecute(Sender: TObject);
begin
  Memo1.WordWrap := Action_WordWrap.Checked;
  Memo1.Font.Assign(Self.Font);// なぜかフォントサイズが変わってしまう場合あり
  TreeView1.Font.Assign(Self.Font);// こっちは、念のため
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  if FModified then
  case Q_Save_ModifiedData() of
    IDYES: if Do_SaveFile() then
      else CanClose := FALSE;
    IDNO: ;
    IDCANCEL: CanClose := FALSE;
    else      CanClose := FALSE;
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FTreeStrings.Free;
end;

procedure TForm1.Memo1Change(Sender: TObject);
begin
  FModified := TRUE;
end;

procedure TForm1.MenuItem_FileClick(Sender: TObject);
begin
  // MenuItem_FileSave.Enabled := FModified;
end;

procedure TForm1.PopupMenu_Memo1Popup(Sender: TObject);
begin
  MenuItem_PopupUnDo.Enabled := Memo1.CanUndo;
  MenuItem_PopupCut.Enabled := Memo1.SelLength > 0;
  MenuItem_PopupCopy.Enabled := Memo1.SelLength > 0;
  MenuItem_PopupPaste.Enabled := Clipbrd.Clipboard.HasFormat(CF_TEXT);
end;

procedure TForm1.PopupMenu_TreeView1Popup(Sender: TObject);
var
  Node: TTreeNode;
begin
  Node := TreeView1.Selected;
  MenuItem_DelNode.Enabled := Assigned(Node) and
    (Node <> TreeView1.Items[0]);
end;

procedure TForm1.TreeView1Click(Sender: TObject);
var
  Node: TTreeNode;
begin
  if Action_View_EditingProperty.Checked then
  begin
    Node := TreeView1.Selected;
    if TreeView1.Focused and
      Assigned(Node) and Assigned(Node.Data) then
    begin
      // Item編集状態に戻す
      Set_EditingProperty(FALSE);
    end;
  end;
end;

procedure TForm1.TreeView1DblClick(Sender: TObject);
var
  Pt: TPoint;
  Node: TTreeNode;
begin
  Pt := Mouse.CursorPos;
  Pt := TreeView1.ScreenToClient(Pt);
  Node := TreeView1.GetNodeAt(Pt.x, Pt.y);
  StatusBar1.SimpleText:= IntToStr(Pt.x) + ', ' + IntToStr(Pt.y);
  if Assigned(Node) then
    //DEBUG('Node.Text = ' + Node.Text)
  else
    Set_EditingProperty(TRUE);
end;

procedure TForm1.TreeView1DragDrop(Sender, Source: TObject; X, Y: Integer);
var
  SrcNode, DstNode, NewNode: TTreeNode;
  SS: TShiftState;
  SrcItem, DstItem, NewItem: TTreeStringsItem;
begin
  SS := GetKeyShiftState();
  SrcNode := TreeView1.Selected;
  DstNode := TreeView1.GetNodeAt(X, Y);

  if Assigned(SrcNode) and Assigned(DstNode) then
  begin
    SrcItem := TTreeStringsItem(SrcNode.Data);
    DstItem := TTreeStringsItem(DstNode.Data);
    if FTreeStrings.IsThere(SrcItem) and
       FTreeStrings.IsThere(DstItem) then
    begin
      if ((SS = []) or (SS = [ssShift])) and
         (Application.MessageBox(
           PChar('移動しますか？' + #13#10 +
           '[' + SrcItem.Caption + ']' +#13#10 + '  >>' + #13#10 +
           '[' + DstItem.Caption + ']'),
           '項目の移動', MB_YESNO) = IDYES) then
      begin
        // 移動
        if SS = [ssShift] then
          NewItem := DstItem.MoveAsSibling(SrcItem)
        else // SS = []
          NewItem := DstItem.MoveAsChild(SrcItem);

        if NewItem = SrcItem then // 移動できました
        begin
          if SS = [ssShift] then
            SrcNode.MoveTo(DstNode, naAdd)
          else
            SrcNode.MoveTo(DstNode, naAddChild);
          TreeView1.Selected := SrcNode;
          FModified := TRUE;
        end;
      end
      else if ((SS = [ssCtrl])or (SS = [ssCtrl, ssShift]))and
         (Application.MessageBox(
           PChar('コピーしますか？' + #13#10 +
           '[' + SrcItem.Caption + ']' +#13#10 + '  >>' + #13#10 +
           '[' + DstItem.Caption + ']'),
           '項目のコピー', MB_YESNO) = IDYES) then
      begin
        // コピー
        if SS = [ssCtrl, ssShift] then
        begin
          NewItem := DstItem.CopyAsSibling(SrcItem);
          NewNode := TreeView1.Items.AddObject(DstNode, NewItem.Caption, NewItem);
        end
        else // SS = [ssCtrl]
        begin
          NewItem := DstItem.CopyAsChild(SrcItem);
          NewNode := TreeView1.Items.AddChildObject(DstNode, NewItem.Caption, NewItem);
        end;

        MakeTreeView(NewNode, NewItem);
        TreeView1.Selected := NewNode;
        FModified := TRUE;
      end;
    end;// if Assigned(SrcItem) and Assigned(DstItem) then
  end;// if Assigned(SrcNode) and Assigned(DstNode) then
end;

procedure TForm1.TreeView1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
var
  SS: TShiftState;
  DstNode, SrcNode: TTreeNode;
begin
  SS := GetKeyShiftState();

  DstNode := TreeView1.GetNodeAt(X, Y);
  SrcNode := TreeView1.Selected;

  Accept := Assigned(DstNode) and Assigned(SrcNode) and
    (DstNode <> SrcNode);

  if Accept and
    ((SS = [])or(SS = [ssCtrl])) then // 直親の子として、移動 or 追加はできない
    Accept := DstNode <> SrcNode.Parent;

  if Accept and
    ((SS = [])or(SS = [ssShift])) then // 子孫ノードへの移動はできない
  while Assigned(DstNode) do
  begin
    if DstNode = SrcNode then
    begin
      Accept := FALSE;
      break;
    end;
    DstNode := DstNode.Parent;
  end;
end;

procedure TForm1.TreeView1Edited(Sender: TObject; Node: TTreeNode; var S: string
  );
begin
  if Assigned(Node) and Assigned(Node.Data) and
    FTreeStrings.IsThere(TTreeStringsItem(Node.Data)) then
  begin
    S := Trim(S);
    if S <> '' then
    begin
      if TTreeStringsItem(Node.Data).Caption <> S then
      begin
        TTreeStringsItem(Node.Data).Caption := S;
        FModified := TRUE;
      end;
    end
    else
    begin
      S := TTreeStringsItem(Node.Data).Caption;
      ShowMessage('空のノード名は無効です');
    end;
  end;
end;

procedure TForm1.TreeView1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if(Key = VK_F2)and Assigned(TreeView1.Selected) then
  begin
    TreeView1.Selected.EditText;
  end;
end;

procedure TForm1.TreeView1SelectionChanged(Sender: TObject);
var
  Memo_OnChange: TNotifyEvent;
  Node: TTreeNode;
begin
  if Action_View_EditingProperty.Checked then
    Exit;

  Memo_OnChange := Memo1.OnChange;
  try
    Memo1.OnChange := nil;

    Node := TreeView1.Selected;
    if Assigned(Node) and Assigned(Node.Data)
      then
      Set_TreeStringsItem_of_Memo(TTreeStringsItem(Node.Data))
    else
    begin
      Set_TreeStringsItem_of_Memo(nil);
    end;

  finally
    Memo1.OnChange := Memo_OnChange;
  end;
end;

procedure TForm1.Set_TreeStringsItem_of_Memo(AItem: TTreeStringsItem);
begin
  if FTreeStrings.IsThere(FTreeStringsItem_of_Memo) then
  begin
    if Memo1.Modified then
    FTreeStringsItem_of_Memo.Strings.Text := Trim(Memo1.Lines.Text);
  end;

  FTreeStringsItem_of_Memo := AItem;

  if FTreeStrings.IsThere(FTreeStringsItem_of_Memo) then
  begin
    Memo1.Lines.Assign(FTreeStringsItem_of_Memo.Strings);
  end
  else
  begin
    Memo1.Clear;
    FTreeStringsItem_of_Memo := nil;
  end;

  Memo1.Modified := FALSE;
end;

procedure TForm1.UpdateCaption_by_FileName();
begin
  if FFileName = '' then
    Caption := Application.Title
  else
    Caption := Application.Title + ': ' + ExtractFileName(FFileName);
end;

function TForm1.CreateIniFile: TIniFile;
begin
  Result := TIniFile.Create(ChangeFileExt(Application.Exename, '.ini'));
end;

procedure TForm1.WMUser(var Msg: TMessage);
var
  IsForward: Boolean;
  S: string;
const
  RE_SEARCH_MODE = 0;
begin
  IsForward := Msg.lParam = 1;
  if FindWord(
    System.UTF8Decode(FindWordForm.Keyword),
    FindWordForm.CaseSensitive,
    FindWordForm.WholeFile,
    Msg.lParam = 1) = FALSE then
  begin
    if FindWordForm.WholeFile then // ファイル全体を検索
      S := 'ファイルの'
    else
      S := '表示項目の';

    if IsForward then // Forward 検索
      S := S + '先頭'
    else
      S := S + '末尾';

    if Application.MessageBox(PChar(S + 'から再検索しますか'),
      '文字列が見つかりませんでした',
      MB_ICONQUESTION or MB_YESNO) = IDYES then
    begin
      if IsForward then // Forward 検索
      begin
        if FindWordForm.WholeFile then // ファイル全体を検索
        if TreeView1.Items.Count > 0 then
          TreeView1.Selected := TreeView1.Items[0];

        Memo1.SelStart := 0;
        Memo1.SelLength := 0;
      end
      else // Backward 検索
      begin
        if FindWordForm.WholeFile then // ファイル全体を検索
        if TreeView1.Items.Count > 0 then
          TreeView1.Selected := TreeView1.Items[TreeView1.Items.Count - 1];

        Memo1.SelStart := Length(Memo1.Text);
        Memo1.SelLength := 0;
      end;

      case RE_SEARCH_MODE of
      0: PostMessage(Handle, Msg.msg, Msg.wParam, Msg.lParam);
      1:begin
          FindWordForm.Show;
          FindWordForm.Button_FindNext.SetFocus;
        end;
      else PostMessage(Handle, Msg.msg, Msg.wParam, Msg.lParam);
      end;// case RE_SEARCH_MODE of

    end; // Application.MessageBox 再検索しますか？
  end; // if FindWord
  if FindWordForm.Visible then
    FindWordForm.SetFocus;
end;

procedure TForm1.AddNode_Next(Node: TTreeNode);
var
  Item, NewItem: TTreeStringsItem;
  NewNode: TTreeNode;
begin
  if Assigned(Node) then
  begin
    Item := TTreeStringsItem(Node.Data);
    if FTreeStrings.IsThere(Item) then
    begin
      NewItem := Item.AddNext('New Node');
      MakeTreeView;
      NewNode := SelectNode_by_Item(NewItem);
      if Assigned(NewNode) then
      begin
        NewNode.EditText;
      end;
    end;
  end;
end;

procedure TForm1.AddNode_Child(Node: TTreeNode);
var
  Item, NewItem: TTreeStringsItem;
  NewNode: TTreeNode;
begin
  if Assigned(Node) then
  begin
    Item := TTreeStringsItem(Node.Data);
    if FTreeStrings.IsThere(Item) then
    begin
      NewItem := Item.AddChild('New Node');
      MakeTreeView;
      NewNode := SelectNode_by_Item(NewItem);
      if Assigned(NewNode) then
      begin
        NewNode.EditText;
      end;
    end;
  end;
end;

procedure TForm1.DelNode(Node: TTreeNode);
var
  Item, Item_Parent: TTreeStringsItem;
begin
  if Assigned(Node) and
    //Assigned(Node.Parent) then
    (Node <> TreeView1.Items[0]) then
  begin
    Item := TTreeStringsItem(Node.Data);
    if FTreeStrings.IsThere(Item) and Assigned(Item.Parent) then
    begin
      Item_Parent := Item.Parent;
      Item_Parent.Delete(Item);
      MakeTreeView;
      SelectNode_by_Item(Item_Parent);
    end;
  end;
end;

procedure TForm1.MoveNode_Up(Node: TTreeNode);
var
  Item: TTreeStringsItem;
begin
  if Assigned(Node) then
  begin
    Item := TTreeStringsItem(Node.Data);
    if FTreeStrings.IsThere(Item) then
    begin
      Item.MoveUp();
      MakeTreeView;
      SelectNode_by_Item(Item);
    end;
  end;
end;

procedure TForm1.MoveNode_Down(Node: TTreeNode);
var
  Item: TTreeStringsItem;
begin
  if Assigned(Node) then
  begin
    Item := TTreeStringsItem(Node.Data);
    if FTreeStrings.IsThere(Item) then
    begin
      Item.MoveDown();
      MakeTreeView;
      SelectNode_by_Item(Item);
    end;
  end;
end;

procedure TForm1.MoveNode_Top(Node: TTreeNode);
var
  Item: TTreeStringsItem;
begin
  if Assigned(Node) then
  begin
    Item := TTreeStringsItem(Node.Data);
    if FTreeStrings.IsThere(Item) then
    begin
      Item.MoveTop();
      MakeTreeView;
      SelectNode_by_Item(Item);
    end;
  end;
end;

procedure TForm1.MoveNode_Bottom(Node: TTreeNode);
var
  Item: TTreeStringsItem;
begin
  if Assigned(Node) then
  begin
    Item := TTreeStringsItem(Node.Data);
    if FTreeStrings.IsThere(Item) then
    begin
      Item.MoveBottom();
      MakeTreeView;
      SelectNode_by_Item(Item);
    end;
  end;
end;

procedure TForm1.Set_EditingProperty(AVisible: Boolean);
var
  Memo_OnChange: TNotifyEvent;
begin
  Action_View_EditingProperty.Checked := AVisible;
  Label_EditingProperty.Visible := AVisible;
  if AVisible then
  begin
    TreeView1.HideSelection := TRUE;
    Memo_OnChange := Memo1.OnChange;
    try
      Memo1.OnChange := nil;
      Set_TreeStringsItem_of_Memo(Self.FTreeStrings);
    finally
      Memo1.OnChange := Memo_OnChange;
    end;

    Memo1.SetFocus;
  end
  else // AVisible = FALSE
  begin
    TreeView1.HideSelection := FALSE;
    if TreeView1.Selected = nil then
      TreeView1.Selected := TreeView1.TopItem
    else
      TreeView1SelectionChanged(TreeView1);
  end;
end;

function TForm1.Q_Save_ModifiedData: Integer;
begin
  Result := Application.MessageBox('変更内容を保存しますか？',
        '変更データが未保存',
        MB_ICONQUESTION or MB_YESNOCANCEL);
end;

procedure TForm1.Do_NewFile();
begin
  TreeView1.Items.Clear;
  FTreeStrings.Clear;
  Memo1.Lines.Clear;
  Memo1.Modified := FALSE;

  FTreeStrings.AddChild('(New Data)');

  MakeTreeView;
  if TreeView1.Items.Count > 0 then
    TreeView1.Items[0].Selected := TRUE;

  FModified := FALSE;
  FFileName := '';
  UpdateCaption_by_FileName();
end;

function TForm1.Do_SaveFile(): Boolean;
begin
  if (FFileName <> '') and FileExists(FFileName) then
    Result := SaveToFile(FFileName)
  else
    Result := Do_SaveFileAs();
end;

function TForm1.Do_SaveFileAs(): Boolean;
begin
  SaveDialog1.InitialDir := ExtractFilePath(FFileName);
  SaveDialog1.FileName := ExtractFileName(FFileName);

  if SaveDialog1.Execute then
    Result := SaveToFile(SaveDialog1.FileName)
  else
    Result := FALSE;
end;

procedure TForm1.LoadFromFile(AFileName: string);
var
  SL: TStringList;
begin
  TreeView1.Enabled := TRUE;
  Set_EditingProperty(FALSE);

  FFileName := AFileName;
  UpdateCaption_by_FileName();

  SL := TStringList.Create;
  try
    Strings_LoadFromFile(SL, FFileName);
    FTreeStrings.LoadFromStrings(SL);
  finally
    SL.Free;
  end;

  MakeTreeView();

  if TreeView1.Items.Count > 0 then
    TreeView1.Items[0].Selected := TRUE;

  if FTreeStrings.Count > 0 then
  else
  begin
    // ツリー構造の無いテキストを開いた場合
    TreeView1.Enabled := FALSE;
    Set_EditingProperty(TRUE);
  end;

  FModified := FALSE;
end;

function TForm1.SaveToFile(AFileName: string): Boolean;
var
  SL: TStringList;
begin
  FFileName := AFileName;
  UpdateCaption_by_FileName();

  if FTreeStrings.IsThere(FTreeStringsItem_of_Memo) then
    Set_TreeStringsItem_of_Memo(FTreeStringsItem_of_Memo);

  SL := TStringList.Create;
  try
    FTreeStrings.SaveToStrings(SL, Action_FileEndStr_in_Saving.Checked);
    Result := Strings_SaveToFile(SL, FFileName);
  finally
    SL.Free;
  end;
  FModified := FALSE;
end;

function TForm1.FindWord(AKeyword: WideString; ACaseSensitive, AWholeFile, AForward: Boolean): Boolean;
var
  WS: WideString;
  I, IStart, L: Integer;
  ItemIndex: Integer;
  WholeList: TList;
  Item: TTreeStringsItem;

  function _Check(IStart: Integer): Boolean; inline;
  begin
    if ACaseSensitive then
      Result := WideSameStr(AKeyWord, Copy(WS, IStart, L))
    else
      Result := WideSameText(AKeyWord, Copy(WS, IStart, L));
  end;

  procedure _AddChildren(AList: TList; AItem: TTreeStringsItem);
  var
    I: Integer;
  begin
    for I := 0 to AItem.Count - 1 do
    begin
      AList.Add(AItem.Items[I]);
      _AddChildren(AList, AItem.Items[I]);
    end;
  end;

begin
  Result := FALSE;

  Memo1.SetFocus;
  WS := UTF8Decode(Memo1.Text);
  L := Length(AKeyword);
  IStart := Memo1.SelStart + 1;
  if(Memo1.SelLength = L) and _Check(IStart) then
  begin
    if AForward then
      Inc(IStart)
    else
      Dec(IStart);
  end;

  if AForward then
    for I := IStart to Length(WS) do
    begin
      Result := _Check(I);
      if Result then break;
    end
  else // Backward
    for I := IStart downto 1 do
    begin
      Result := _Check(I);
      if Result then break;
    end;

  if Result then
  begin
    Memo1.SelStart := I - 1;
    Memo1.SelLength := L;
  end;

  if not Result and AWholeFile then
  begin
    WholeList := TList.Create;
    try
      _AddChildren(WholeList, FTreeStrings);

      ItemIndex := WholeList.IndexOf(FTreeStringsItem_of_Memo);
      if ItemIndex < 0 then
        // ERROR
      else if AForward then
      begin
        Inc(ItemIndex);
        while ItemIndex < WholeList.Count do
        begin
          Item := TTreeStringsItem(WholeList.Items[ItemIndex]);

          WS := UTF8Decode(Item.Strings.Text);
          for I := 1 to Length(WS) do
          begin
            Result := _Check(I);
            if Result then break;
          end;// for I := 1 to Length(WS) do

          if Result then break;
          Inc(ItemIndex);
        end;// while ItemIndex < WholeList.Count do

      end
      else // Backward (not Forward)
      begin
        Dec(ItemIndex);
        while ItemIndex >= 0 do
        begin
          Item := TTreeStringsItem(WholeList.Items[ItemIndex]);
          WS := UTF8Decode(Item.Strings.Text);
          for I := Length(WS) downto 1 do
          begin
            Result := _Check(I);
            if Result then break;
          end;// for I := Length(WS) downto 1 do

          if Result then break;
          Dec(ItemIndex);
        end;// while ItemIndex >= 0 do

      end;

      if Result then
      begin
        SelectNode_by_Item(Item);
        Memo1.SelStart := I - 1;
        Memo1.SelLength := L;
      end;

    finally
      WholeList.Free;
    end;
  end;
end;

procedure TForm1.MakeTreeView;
begin
  MakeTreeView(nil, FTreeStrings);
end;

procedure TForm1.MakeTreeView(ANode: TTreeNode; AItem: TTreeStringsItem);
var
  TreeView1_OnSelectionChanged: TNotifyEvent;
  I: Integer;

  procedure _Add(AParent: TTreeNode; AItem: TTreeStringsItem);
  var
    I: Integer;
    NewNode: TTreeNode;
  begin
    NewNode := TreeView1.Items.AddChildObject(AParent, AItem.Caption, AItem);
    for I := 0 to AItem.Count - 1 do
    begin
      _Add(NewNode, AItem.Items[I]);
    end;
  end;
begin
  TreeView1_OnSelectionChanged := TreeView1.OnSelectionChanged;
  try
    TreeView1.OnSelectionChanged := nil;

    TreeView1.BeginUpdate;
    try
      if Assigned(ANode) then
      begin
        ANode.Text := AItem.Caption;
        ANode.Data := AItem;
        ANode.DeleteChildren;
      end
      else
        TreeView1.Items.Clear;

      for I := 0 to AItem.Count - 1 do
      begin
        _Add(ANode, AItem.Items[I]);
      end;

    finally
      TreeView1.EndUpdate;
    end;

    TreeView1.FullExpand;

    if Assigned(ANode) then
      TreeView1.Selected := ANode
    else if TreeView1.Items.Count > 0 then
      TreeView1.Selected := TreeView1.Items[0];

    TreeView1SelectionChanged(TreeView1);
  finally
    TreeView1.OnSelectionChanged := TreeView1_OnSelectionChanged;
  end;
end;

function TForm1.SelectNode_by_Item(AItem: TTreeStringsItem): TTreeNode;
var
  I: Integer;

  function _Check(ANode: TTreeNode): TTreeNode;
  var
    I: Integer;
  begin
    Result := nil;
    if ANode.Data = Pointer(AItem) then
    begin
      Result := ANode;
    end
    else
    begin
      for I := 0 to ANode.Count - 1 do
      begin
        Result := _Check(ANode.Items[I]);
        if Assigned(Result) then
          break;
      end;
    end;
  end;

begin
  Result := nil;
  if not Assigned(AItem) then
    Exit;

  for I := 0 to TreeView1.Items.Count - 1 do
  begin
    Result := _Check(TreeView1.Items[I]);
    if Assigned(Result) then
    begin
      TreeView1.Selected := Result;
      break;
    end;
  end;
end;

end.

